package com.dsic.gj_erp.controller.jcsj;


import com.alibaba.fastjson.JSONObject;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.EmGcrl;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.service.jcsj.EmGcrlService;
import com.dsic.gj_erp.service.jcsj.EmSbcnpService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-09-15
 */
@RestController
@RequestMapping("/emGcrl")
@Api(tags = "工厂日历")
public class EmGcrlController {
    @Autowired
    EmGcrlService emGcrlService;

    @ApiOperation(value = "查询")
    @PostMapping(value = "/getList")
    public ResultBean getList(@RequestBody JSONObject json) {
        List<EmGcrl> emGcrls= emGcrlService.getList(json);
        return new ResultBean(emGcrls);
    }


    @ApiOperation(value = "批量修改")
    @PostMapping(value = "/update")
    public ResultBean update(@RequestBody List<EmGcrl> emGcrls) {
        emGcrlService.update(emGcrls);

        return new ResultBean();
    }

    @ApiOperation(value = "生成工厂日历")
    @PostMapping(value = "/generate")
    public ResultBean generate(@RequestParam String nf) {
        emGcrlService.generate(nf);

        return new ResultBean();
    }
}

