package com.dsic.gj_erp.controller.jhgk;


import cn.hutool.core.util.StrUtil;
import com.alibaba.excel.EasyExcel;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.jcsj.EmSbcnp;
import com.dsic.gj_erp.bean.jhgk.DmDhqdp;
import com.dsic.gj_erp.bean.jhgk.DmQfxq;
import com.dsic.gj_erp.bean.jhgk.DmSygd;
import com.dsic.gj_erp.bean.jhgk.DmSygdMx;
import com.dsic.gj_erp.bean.jhgk.excel.QfExcel;
import com.dsic.gj_erp.bean.jhgk.excel.SyExcel;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.listeners.ExcelQFListener;
import com.dsic.gj_erp.listeners.ExcelSYListener;
import com.dsic.gj_erp.service.jhgk.DmSygdService;
import com.dsic.gj_erp.service.sy.SYService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-10-09
 */
@RestController
@RequestMapping("/dmSygd")
public class DmSygdController {

    @Resource
    DmSygdService service;
    @RequestMapping("/getList")
    @AuthFunction
    public ResultBean getList(@RequestBody DmSygd sygd){
        List<DmSygd> list= service.list(new QueryWrapper<DmSygd>()
                                .eq("gd_zt",sygd.getGdZt())
                .ge(StrUtil.isNotEmpty(sygd.getBeginTime()),"sl_sj",sygd.getBeginTime())
                .le(StrUtil.isNotEmpty(sygd.getEndTime()),"sl_sj",sygd.getEndTime())
                .orderByAsc("sl_sj,dc_ch,dc_pl")
        );
        return new ResultBean(list);
    }

    @PostMapping("/upload")
    @AuthFunction
    @ResponseBody
    public ResultBean uploadSy(@RequestParam("file") MultipartFile file , HttpServletRequest req) throws Exception, CustomException {

        ExcelSYListener objectListener = new ExcelSYListener();
        EasyExcel.read(file.getInputStream(), SyExcel.class, objectListener).sheet(0).headRowNumber(1).doRead();
        List<SyExcel> objList = objectListener.getObjectList();
        service.uploadSy(objList,req);
        return new ResultBean();
    }

    //提交
    //审核
    //退回

    @ApiOperation(value = "批量提交/退回")
    @PostMapping("/tj")
    @AuthFunction
    @ResponseBody
    public ResultBean tj(@RequestBody List<DmSygd> list){
        service.tj(list);
        return new ResultBean();
    }

    @ApiOperation(value = "批量审核")
    @PostMapping(value = "/sh")
    public ResultBean sh(@RequestBody List<DmSygd> dmSygds) {
        service.sh(dmSygds);
        return new ResultBean();
    }


}

