package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.pgd.PgdPwjh;
import com.dsic.gj_erp.bean.pgd.PgdPwjh;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.pgd.PgdPwjhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdPwjh")
public class PgdPwjhController {
    
    @Autowired
    PgdPwjhService pgdPwjhService;
    
    @PostMapping("/getPwPgd")
    @ResponseBody
    public ResultBean getPwPgd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        QueryWrapper<PgdPwjh> qw =new QueryWrapper<>();


        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"czbh",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"pl",(String)map.get("pl"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("fd")),"fd",(String)map.get("fd"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("zt")),"zt",(String)map.get("zt"));
        qw.orderBy(true,true,"czbh","pl","fd");
        return new ResultBean(pgdPwjhService.list(qw));

    }

    @PostMapping("/savePwPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean savePwPgdXd(HttpServletRequest req, @RequestBody List<PgdPwjh> list) throws Exception, CustomException {
        pgdPwjhService.savePwPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/savePwPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean savePwPgdXdBack(HttpServletRequest req, @RequestBody List<PgdPwjh>list) throws Exception, CustomException {
        pgdPwjhService.savePwPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/savePwPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean savePwPgdFk(HttpServletRequest req, @RequestBody List<PgdPwjh>list) throws Exception, CustomException {
        pgdPwjhService.savePwPgdFk(list,req);
        return new ResultBean();
    }

}

