package com.dsic.gj_erp.controller.pgd;


import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.dsic.gj_erp.annotation.AuthFunction;
import com.dsic.gj_erp.bean.ResultBean;
import com.dsic.gj_erp.bean.pgd.PgdQmjh;
import com.dsic.gj_erp.bean.pgd.PgdQmjh;
import com.dsic.gj_erp.exception.CustomException;
import com.dsic.gj_erp.service.pgd.PgdQmjhService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@RestController
@RequestMapping("/pgdQmjh")
public class PgdQmjhController {
    @Autowired
    PgdQmjhService  pgdQmjhService;



    @PostMapping("/getQmPgd")
    @ResponseBody
    public ResultBean getQmPgd(HttpServletRequest req, @RequestBody Map map) throws Exception, CustomException {
        QueryWrapper<PgdQmjh> qw =new QueryWrapper<>();


        qw.eq(StrUtil.isNotEmpty((String)map.get("dcch")),"czbh",(String)map.get("dcch"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("pl")),"pl",(String)map.get("pl"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("fd")),"fd",(String)map.get("fd"));
        qw.eq(StrUtil.isNotEmpty((String)map.get("zt")),"zt",(String)map.get("zt"));
        qw.orderBy(true,true,"czbh","pl","fd");
        return new ResultBean(pgdQmjhService.list(qw));

    }

    @PostMapping("/saveQmPgdXd")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQmPgdXd(HttpServletRequest req, @RequestBody List<PgdQmjh> list) throws Exception, CustomException {
        pgdQmjhService.saveQmPgdXd(list,req);
        return new ResultBean();
    }

    @PostMapping("/saveQmPgdXdBack")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQmPgdXdBack(HttpServletRequest req, @RequestBody List<PgdQmjh>list) throws Exception, CustomException {
        pgdQmjhService.saveQmPgdXdBack(list,req);
        return new ResultBean();
    }



    @PostMapping("/saveQmPgdFk")
    @ResponseBody
    @AuthFunction
    public ResultBean saveQmPgdFk(HttpServletRequest req, @RequestBody List<PgdQmjh>list) throws Exception, CustomException {
        pgdQmjhService.saveQmPgdFk(list,req) ;
        return new ResultBean();
    }
}

