package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.bean.pgd.PgdPkjh;
import com.dsic.gj_erp.bean.pgd.PgdQgjh;
import com.dsic.gj_erp.bean.pgd.PgdQmjh;
import com.dsic.gj_erp.mapper.pgd.PgdQmjhMapper;
import com.dsic.gj_erp.service.pgd.PgdQmjhService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
public class PgdQmjhServiceImpl extends ServiceImpl<PgdQmjhMapper, PgdQmjh> implements PgdQmjhService {
    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveQmPgdXd(List<PgdQmjh> qmjhs, HttpServletRequest request) {
        List<PgdQmjh>ups= new ArrayList<>();
        qmjhs.forEach(f->{
            PgdQmjh e= new PgdQmjh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("02");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public void saveQmPgdFk(List<PgdQmjh> qmjhs, HttpServletRequest request) {
        List<PgdQmjh>ups= new ArrayList<>();
        qmjhs.forEach(f->{
            PgdQmjh e= new PgdQmjh();
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("09");
            e.setFkyy(f.getFkyy());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Override

    @Transactional(rollbackFor = Exception.class)
    public void saveQmPgdXdBack(List<PgdQmjh> qmjhs, HttpServletRequest request) {
        List<PgdQmjh>ups= new ArrayList<>();
        qmjhs.forEach(f->{
            PgdQmjh e= new PgdQmjh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            if(f.getZt().equals("02")){
                e.setZt("01");
            }
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }
}
