package com.dsic.gj_erp.service.pgd.impl;

import cn.hutool.core.date.DateUtil;
import com.dsic.gj_erp.bean.pgd.PgdTzjh;
import com.dsic.gj_erp.mapper.pgd.PgdTzjhMapper;
import com.dsic.gj_erp.service.pgd.PgdTzjhService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.Data;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xn
 * @since 2023-11-13
 */
@Service
public class PgdTzjhServiceImpl extends ServiceImpl<PgdTzjhMapper, PgdTzjh> implements PgdTzjhService {


    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveTzjhPgdXd(List<PgdTzjh> tzjhs, HttpServletRequest request) {
        List<PgdTzjh>ups= new ArrayList<>();
        tzjhs.forEach(f->{
            PgdTzjh e= new PgdTzjh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("02");
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveTzjhPgdFk(List<PgdTzjh> tzjhs, HttpServletRequest request) {
        List<PgdTzjh>ups= new ArrayList<>();
        tzjhs.forEach(f->{
            PgdTzjh e= new PgdTzjh();
            e.setFkry((String) request.getAttribute("yhms"));
            e.setFkrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            e.setZt("09");
            e.setFkyy(f.getFkyy());
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }
    @Transactional(rollbackFor = Exception.class)
    @Override
    public void saveTzjhPgdXdBack(List<PgdTzjh> tzjhs, HttpServletRequest request) {
        List<PgdTzjh>ups= new ArrayList<>();
        tzjhs.forEach(f->{
            PgdTzjh e= new PgdTzjh();
            e.setXfry((String) request.getAttribute("yhms"));
            e.setXfrq(DateUtil.format(DateUtil.date(), "yyyy/MM/dd HH:mm:ss"));
            if(f.getZt().equals("02")){
                e.setZt("01");
            }
            e.setId(f.getId());
            ups.add(e);
        });
        this.updateBatchById(ups);
    }
}
